@echo off

REM Do NOT change the following lines!
set Arg1=%1
set Arg2=%2
set Arg3=%3
set Arg4=%4

REM You may fumble with the rest, but
REM use ArgN instead of the default %1 etc. parameters

chdir %Arg1%
echo ** Assemble and link %Arg2% to %Arg2%.dll **
echo.

set Options=/SUBSYSTEM:CONSOLE /DLL /DEF:TmpDllEx.def
set CleanUp=NO
set CleanDef=NO

echo.
echo Options: %Options%
echo.
\masm32\bin\ml /nologo /c /coff %Arg2%.asm
if errorlevel 1 goto ErrAsm
\masm32\BIN\link /nologo %Options% %Arg2%.obj
if errorlevel 1 goto ErrLink
if exist %Arg3% Goto TestMe
pause
exit
:TestMe
echo.
echo Test run using %Arg3% %Arg4%
echo ________________________________________________
%Arg3% %Arg4%
echo ________________________________________________
pause
if %CleanUp%==YES del %Arg2%.obj
if %CleanUp%==YES del %Arg2%.lib
if %CleanUp%==YES del %Arg2%.exp
if %CleanDef%==YES del TmpDllEx.def
CLS
exit
:ErrAsm
echo Assembly error
pause
exit
:ErrLink
echo Link error
pause
CLS